<?php 

# ------------------------------------------------
# License and copyright:
#
# This program is designed and copyrighted by
# Aaron Colman on Feb 27, 2004 under the terms 
# of the GPL provided under gpl.txt
#
# The original distribution can be found at:
# http://www.ibasics.biz
#
# I will be updating this software as time goes
# on, if you want the newest version... that's 
# where you need to go.
#
# No warranty of any kind is implied or expressed.
# You're also liable for your own actions with this
# script. If something goes wrong, it's your fault 
# and you get to deal with the consequences. I'm 
# not going to pay for it.
# ------------------------------------------------

include('evilness-filter.php');
include('functions.php');

# Database information goes here. Server, user, password and database.
$MySQL_server = '';
$MySQL_user = '';
$MySQL_password = '';
$MySQL_database = '';

# The URL of your main page. Don't end with a slash. Use single quotes.
# Example: $siteURL = 'http://www.ibasics.biz';
$siteURL = '';

# The URL-based directory (not the filesystem one!) that these 
# script files are in. Lead with a slash, don't end with one.
# Example: $ResponderDirectory = '/inf_responder';
$ResponderDirectory = '/inf_resp';

# $Max_Send_Count is the maximum number of messages allowed during
# any one sendmails.php run. This is to keep your mail server from 
# bursting into flames by breaking large batches into smaller bits.
$Max_Send_Count = 250;

# $Last_Activity_Trim is the number of months that should pass before
# A user is automatically trimmed from the list. This is to prevent the 
# database from growing too large with old subscribers. 
# Set to 0 to disable.
$Last_Activity_Trim = 6;

# $Confirmation_Expiration is the number of seconds for a confirmation message to
# expire.  1 day is 86400, 3 days is 259200, 7 days (a week) is 604800.
# $Confirmation_Expiration = 604800;
$Confirmation_Expiration = 259200;

# You will now need 2 lengthy strings of random characters.
# They are used to encrypt login and password details so 
# they're not accessible from a view source.
# Sample [Don't actually use this!!]: zFpjN2q8VpJzaf48BRtjanz

$pass_key1  = '';
$pass_key2  = '';

# Login and password for the admin console
$auth_login = "";
$auth_pass = "";

# I've added this after some thought. While there's nothing to censor from 
# your users, it's possible that someone might try to confirm flood someone else.
# To prevent this, you can add thier email address to the $black_list variable
# and it will never send them a confirmation.
# I don't expect there to be a lot of this, so I'm not going to database it for
# the time being. Maybe in a later version.
# Example: $black_list = "john@doe.org, jane@tarzan.biz, jimmy@olsen.net";
$black_list = "";

# Check to make sure that config variables are set to something.
include('config-check.php');

# Currently unused - Get_Config();
?>