<?php 
# ------------------------------------------------
# License and copyright:
#
# This program is designed and copyrighted by
# Aaron Colman on Feb 27, 2004 under the terms 
# of the GPL provided under gpl.txt
#
# The original distribution can be found at:
# http://www.ibasics.biz
#
# I will be updating this software as time goes
# on, if you want the newest version... that's 
# where you need to go.
#
# No warranty of any kind is implied or expressed.
# You're also liable for your own actions with this
# script. If something goes wrong, it's your fault 
# and you get to deal with the consequences. I'm 
# not going to pay for it.
# ------------------------------------------------
include('config.php');

DB_connect();

# ------------------------------------------------
# Quick Hacks section - Stuff added later on
# request
# ------------------------------------------------
# This array allows you to turn off the confirm
# message for a particular responder. The index
# of the array is the responder number.

# $disable_conf_msg['1'] = FALSE;

# ------------------------------------------------
# Set this to true if you want to automatically
# call sendmails when a person subscribes.
#
# Set this in conjuction with $disable_conf_msg
# if you want to use a responder message for
# confirmation instead of the automatic one.

$auto_call_sendmails = TRUE;

# ------------------------------------------------
# Set redirect to TRUE and it'll attempt to redirect
# the user after they sign up to the place specified
# in the array. The number should be the responder ID
# that they're joining.

$redirect_afterconfirm = FALSE;
#$AfterConfirmationLink['1'] = $siteURL;
#$AfterConfirmationLink['2'] = $siteURL;
# ------------------------------------------------

function AddCustomFields() {
  global $Email_Address, $Responder_ID;
  global $FirstName, $LastName, $DB_LinkID;

  $query = "SELECT * FROM InfResp_customfields";
  $result = mysql_query($query)
            or die("Invalid query: " . mysql_error());
  $i = 0;
  $FieldNamesStr = "";
  while ($i < mysql_num_fields($result)) {
     $meta = mysql_fetch_field($result, $i);
     if ($meta) {
        $FieldNamesStr = $FieldNamesStr . trim($meta->name) . ",";
     }
     $i++;
  }
  $FieldNamesStr   = trim((trim($FieldNamesStr)), ",");
  $FieldNamesArray = explode(',',$FieldNamesStr);

  $CustomFieldsExist = FALSE;

  foreach ($FieldNamesArray as $key => $value) {
      $blah = "cf_".$value;
      $reqblah = trim($_REQUEST[$blah]);
      if (empty($reqblah)) {
         $CustomFieldsArray[$value] = "";
      } else {
         $CustomFieldsArray[$value] = MakeSafe($reqblah);
         $CustomFieldsExist = TRUE;
      }
  }

  #------------- Mandatory fields checking ------------------
  # if (empty($CustomFieldsArray['blah'])) { die('Error Message'); }

  #----------------------------------------------------------

  # --- Custom code ---
  $Fullname = "$FirstName $LastName";
  $CustomFieldsArray['full_name'] = $Fullname;
  # -------------------

  $CustomFieldsArray['email_attached'] = $Email_Address;
  $CustomFieldsArray['resp_attached']  = $Responder_ID;
  $CustomFieldsArray['user_attached']  = "0";

     $query = "SELECT * FROM InfResp_customfields WHERE email_attached = '$Email_Address' AND resp_attached = '$Responder_ID'";
     $result = mysql_query($query)
               or die("Invalid query: " . mysql_error());

     if (mysql_num_rows($result) > 0) {
         $query = "DELETE FROM InfResp_customfields WHERE email_attached = '$Email_Address' AND resp_attached = '$Responder_ID'";
         $result = mysql_query($query)
                   or die("Invalid query: " . mysql_error());
     }

     $fieldstr = "";
     $valuestr = "";
     foreach ($CustomFieldsArray as $key => $value) {
       $fieldstr .= $key.",";
       $valuestr .= "'".$value."',";
     }
     $fieldstr = trim((trim($fieldstr)), ",");
     $valuestr = trim((trim($valuestr)), ",");
     $query = "INSERT INTO InfResp_customfields ($fieldstr) VALUES($valuestr)";
     $DB_result = mysql_query($query)
         or die("Invalid query: " . mysql_error());
}

function CallSendMails() {
  include('sendmails.php');
}

# ------------------------------------------------

$IPaddy    = $_SERVER['REMOTE_ADDR'];

$SilentMode = MakeSafe($_REQUEST['s']);
if ($SilentMode == 1) {  }
   else { $SilentMode = 0; }

# Get data, trim any spaces and make it XSS/SQL Injection immune.
$FirstName      = MakeSafe($_REQUEST['f']);
$LastName       = MakeSafe($_REQUEST['l']);
$Email_Address  = stripnl(MakeSafe($_REQUEST['e']));
$Email_Address  = str_replace(">","",$Email_Address);
$Email_Address  = str_replace("<","",$Email_Address);
$Email_Address  = str_replace('/',"",$Email_Address);
$Email_Address  = str_replace('..',"",$Email_Address);

$Confirm_String = MakeSafe($_REQUEST['c']);
$Responder_ID   = MakeSafe($_REQUEST['r']);
$action         = MakeSafe($_REQUEST['a']);
$HandleHTML     = MakeSafe($_REQUEST['h']);

$IPaddy    = $_SERVER['REMOTE_ADDR'];

if (is_numeric($Responder_ID)) { }
  else {
   # A small bit of magic to filter out any screwy crackerness of the RespID
   $Responder_ID = NULL;
  }

if ($HandleHTML == 1) {  }
   else { $HandleHTML = 0; }

if (($redirect_afterconfirm == TRUE) AND (!(empty($AfterConfirmationLink[$Responder_ID]))) AND ($action == "addsub")) {
    $SilentMode = 1;
}

if ($SilentMode != 1) { 
   Header("Cache-Control: no-cache");
   Header("Pragma: no-cache");
   include('page.open.php'); 
}

# ------- Clear out expired confirmations -------

  $Current_Time = time();
  $query = "SELECT Confirm_ResponderID,Confirm_EmailAddy FROM InfResp_confirmations WHERE Confirm_Expiration < '$Current_Time'";
  $DB_result = mysql_query($query)
       or die("Invalid query: " . mysql_error());
   while ($row = mysql_fetch_object($DB_result)) {
      $BLAH_Responder_ID = $row->Confirm_ResponderID;
      $BLAH_Email_Address = $row->Confirm_EmailAddy;
      $query = "DELETE FROM InfResp_customfields WHERE email_attached = '$BLAH_Email_Address' AND resp_attached = '$BLAH_Responder_ID'";
      $result = mysql_query($query)
                or die("Invalid query: " . mysql_error());
   }
  $query = "DELETE FROM InfResp_confirmations WHERE Confirm_Expiration < '$Current_Time'";
  $DB_result = mysql_query($query)
       or die("Invalid query: " . mysql_error());
  #print time();


# ------------------------------ Subscribe -------------------------------

if ($action == "sendconfirm") {

 if (($Responder_ID) && ($Email_Address)) {

  if (!(ResponderExists($Responder_ID)))
    { die("Responder $Responder_ID does not exist"); }

  if (IsInList($black_list,$Email_Address)) { 
     if ($SilentMode != 1) { die("Sorry, that email address has been black listed."); }
     else { die(""); }
  }

  # Check database for duplicate entry.
  # If no duplicate entry exists, add new entry.
  $ResultVar = UserIsSubscribed();
   if ($ResultVar) {
      GetResponderInfo();
      if ($SilentMode != 1) { 
         print "<br> \n";
         print "ERROR: $Email_Address is already subscribed to $DB_ResponderName! <br> \n";
      }
   }
   else {
      $Random_ConfStr = str_makerand(14, 20, TRUE, FALSE, TRUE);
      $Conf_type = $action;
      $Time_To_Expire = time() + $Confirmation_Expiration;

      GetResponderInfo();

      $query = "SELECT * FROM InfResp_confirmations 
                WHERE Confirm_ResponderID = '$Responder_ID' 
                  AND Confirm_EmailAddy   = '$Email_Address' 
                  AND Confirm_Type        = 'sendconfirm'";
      $DB_result = mysql_query($query)
           or die("Invalid query: " . mysql_error());
   
      if (mysql_num_rows($DB_result) == 0) {

          AddCustomFields();

          $query = "INSERT INTO InfResp_confirmations (Confirm_ResponderID, Confirm_EmailAddy, Confirm_String, Confirm_Type, Confirm_Expiration)
                    VALUES('$Responder_ID', '$Email_Address', '$Random_ConfStr', '$Conf_type', '$Time_To_Expire')";
          $DB_result = mysql_query($query)
               or die("Invalid query: " . mysql_error());
     
        $URL=$siteURL.$ResponderDirectory."/subhandler.php?h=$HandleHTML&a=addsub&r=$Responder_ID&e=$Email_Address&f=$FirstName&l=$LastName&c=$Random_ConfStr";

$subscribe_confirm_msg =
"Hello!
Thank you for subscribing to $DB_ResponderName.

You may need to add $DB_ReplyToEmail to your spam filter
\"whitelist\" in order to receive these messages.

If you did not subscribe or did so by accident, just ignore this
email. Otherwise you will need to confirm your subscription by
clicking here:\n$URL

If your email software cannot handle hyperlinks then you will need
to copy and paste the following into your browser:
$URL

Sincerely,
$DB_OwnerName.
$DB_OwnerEmail";

        if ($SilentMode != 1) { 
            print "<br> \n ";
            print "Confirmation email sent to $Email_Address! Please check your inbox. <br> \n ";
        }
        $subscribe_email_subject = "$DB_ResponderName -- Your confirmation is needed.";

        # Some mail() versions have trouble handling pipe symbols. Remove them.
        $Email_Address           = stripnl(str_replace("|","",$Email_Address));
        $subscribe_email_subject = stripnl(str_replace("|","",$subscribe_email_subject));
        $subscribe_confirm_msg   = str_replace("|","",$subscribe_confirm_msg);
        $DB_OwnerName            = str_replace("|","",$DB_OwnerName);
        $DB_ReplyToEmail         = str_replace("|","",$DB_ReplyToEmail);
        $notify_email_subject    = str_replace("|","",$notify_email_subject);
        $subscribe_notify_msg    = str_replace("|","",$subscribe_notify_msg);
        $unsub_confirm_msg       = str_replace("|","",$unsub_confirm_msg);
        $unsub_email_subject     = str_replace("|","",$unsub_email_subject);
        $unsub_notify_msg        = str_replace("|","",$unsub_notify_msg);

        mail($Email_Address, $subscribe_email_subject, $subscribe_confirm_msg, "From: $DB_OwnerName < $DB_ReplyToEmail >");
      } else {
        if ($SilentMode != 1) { 
           print "<br> \n";
           print "ERROR: $Email_Address has already been sent a confirmation email for $DB_ResponderName!<br>\n";
        }
      }
 }
}
 else {
    if ($SilentMode != 1) { 
       print "<br> \n";
       print "Error: Missing Email address or Responder ID! <br> \n";
    }
 }
}

elseif ($action == "addsub") {

 if (($Responder_ID) && ($Email_Address)) {

   if (!(ResponderExists($Responder_ID)))
      { die("Responder $Responder_ID does not exist"); }

   if (IsInList($black_list,$Email_Address)) { die("Sorry, that email address has been black listed."); }

   $query = "SELECT * FROM InfResp_confirmations 
             WHERE Confirm_ResponderID = '$Responder_ID' 
               AND Confirm_EmailAddy   = '$Email_Address' 
               AND Confirm_String      = '$Confirm_String' 
               AND Confirm_Type        = 'sendconfirm'";
   $DB_result = mysql_query($query)
        or die("Invalid query: " . mysql_error());

   if (mysql_num_rows($DB_result) > 0) {
   
   # Check database for duplicate entry.
   # If no duplicate entry exists, add new entry.
   $ResultVar = UserIsSubscribed();
     if ($ResultVar) {
        GetResponderInfo();
        print "<br> \n";
        print "ERROR: $Email_Address is already subscribed to $DB_ResponderName! <br> \n";
     }
     else {
       $Set_RespID = $Responder_ID;
       $Set_SentMsgs = '';
       $Set_Email = $Email_Address;
       $Set_TimeJoined = time();

       if ($HandleHTML == 1) { $Set_HTML = TRUE; }
          else { $Set_HTML = FALSE; }

       $query = "INSERT INTO InfResp_subscribers (ResponderID, SentMsgs, EmailAddress, TimeJoined, Real_TimeJoined, CanReceiveHTML, LastActivity, FirstName, LastName, IP_Addy) 
                 VALUES('$Set_RespID', '$Set_SentMsgs', '$Set_Email', '$Set_TimeJoined', '$Set_TimeJoined', '$Set_HTML', '$Set_TimeJoined', '$FirstName', '$LastName', '$IPaddy')";
       $DB_result = mysql_query($query)
            or die("Invalid query: " . mysql_error());

       $ins_ID=mysql_insert_id();
       $query = "UPDATE InfResp_customfields 
                 SET user_attached = '$ins_ID'
                 WHERE email_attached = '$Email_Address' AND resp_attached = '$Responder_ID'";
       $DB_result = mysql_query($query)
            or die("Invalid query: " . mysql_error());

       $query = "DELETE FROM InfResp_confirmations 
                 WHERE Confirm_ResponderID = '$Responder_ID' 
                   AND Confirm_EmailAddy   = '$Email_Address' 
                   AND Confirm_Type        = 'sendconfirm'";
       $DB_result = mysql_query($query)
            or die("Invalid query: " . mysql_error());

       GetResponderInfo();

       if ($SilentMode != 1) {
         print "<br> \n";
         print "Subscription complete - <strong> $Email_Address </strong>has been subscribed to <strong>$DB_ResponderName</strong>.<br> \n";
       }
      
       $URL=$siteURL.$ResponderDirectory."/subhandler.php?h=$HandleHTML&a=unsub&r=$Responder_ID&e=$Email_Address";

$subscribe_notify_msg =
"Hello!

You are now subscribed to $DB_ResponderName.

If you do not start receiving your subscription on time please
check your spam settings before contacting the owner. Many times 
ISPs will mistake these messages as spam and block them. You may
need to specifically \"whitelist\" these messages.

If you need help with this contact your ISP or request a message
resend from $DB_OwnerName at $DB_ReplyToEmail.

If you need to unsubscribe you can do so at any time by
clicking here:\n$URL

If your email software cannot handle hyperlinks then you will need
to copy and paste the following into your browser:
$URL

Sincerely,
$DB_OwnerName.
$DB_OwnerEmail";

     if ($disable_conf_msg[$Responder_ID] != TRUE) {
         $notify_email_subject = "$DB_ResponderName -- Welcome!";

         # Some mail() versions have trouble handling pipe symbols. Remove them.
         $Email_Address           = stripnl(str_replace("|","",$Email_Address));
         $subscribe_email_subject = stripnl(str_replace("|","",$subscribe_email_subject));
         $subscribe_confirm_msg   = str_replace("|","",$subscribe_confirm_msg);
         $DB_OwnerName            = str_replace("|","",$DB_OwnerName);
         $DB_ReplyToEmail         = str_replace("|","",$DB_ReplyToEmail);
         $notify_email_subject    = str_replace("|","",$notify_email_subject);
         $subscribe_notify_msg    = str_replace("|","",$subscribe_notify_msg);
         $unsub_confirm_msg       = str_replace("|","",$unsub_confirm_msg);
         $unsub_email_subject     = str_replace("|","",$unsub_email_subject);
         $unsub_notify_msg        = str_replace("|","",$unsub_notify_msg);

         mail($Email_Address, $notify_email_subject, $subscribe_notify_msg, "From: $DB_OwnerName < $DB_ReplyToEmail >");
     }
     if ($auto_call_sendmails == TRUE) { 
            # Disconnect, call sendmails, reconnect.
            DB_disconnect();
            CallSendMails();
            DB_connect();
     }
     $redirect_it = TRUE;
    }
   }
   else {
     print "<br> \n";     
     print "Your code string didn't match or has expired. Please try again. <br> \n";
   }
 } 
 else {
     print "<br> \n";
     print "Error: There is a problem with your Email address or Responder ID! <br> \n";
 }
}

# ----------------------------- Unsubscribe ------------------------------

elseif ($action == "unsub") {
 # Start the unsub process and send the unsub confirmation mail

 if (($Responder_ID) && ($Email_Address)) {

  if (!(ResponderExists($Responder_ID)))
     { die("Responder $Responder_ID does not exist"); }

  # Check database to make sure that they're actually subscribed.
  $ResultVar = UserIsSubscribed();
   if (!($ResultVar)) {
      GetResponderInfo();
      print "<br> \n";
      print "ERROR: $Email_Address is not subscribed to $DB_ResponderName! <br> \n";
   }
   else {
      $Random_ConfStr = str_makerand(14, 20, TRUE, FALSE, TRUE);
      $Conf_type = $action;
      $Time_To_Expire = time() + $Confirmation_Expiration;

      $query = "SELECT * FROM InfResp_confirmations 
                WHERE Confirm_ResponderID = '$Responder_ID' 
                  AND Confirm_EmailAddy   = '$Email_Address' 
                  AND Confirm_Type        = 'unsub'";
      $DB_result = mysql_query($query)
           or die("Invalid query: " . mysql_error());

      if (mysql_num_rows($DB_result) < 1) {
         $query = "INSERT INTO InfResp_confirmations (Confirm_ResponderID, Confirm_EmailAddy, Confirm_String, Confirm_Type, Confirm_Expiration)
                   VALUES('$Responder_ID', '$Email_Address', '$Random_ConfStr', '$Conf_type', '$Time_To_Expire')";
         $DB_result = mysql_query($query)
              or die("Invalid query: " . mysql_error());
      }
  
      $URL=$siteURL.$ResponderDirectory."/subhandler.php?h=$HandleHTML&a=confunsub&r=$Responder_ID&e=$Email_Address&c=$Random_ConfStr";
 
      GetResponderInfo();

$unsub_confirm_msg =
"Hi,

Sorry to see you go. In order to keep others from removing you
without your consent you'll need to confirm the request.

If you did not unsubscribe or did so by accident, just ignore this
email. Otherwise you will need to confirm your unsubscription by
clicking here:$URL

If your email software cannot handle hyperlinks then you will need
to copy and paste the following into your browser:
$URL 

$DB_OwnerName.
$DB_OwnerEmail";

    print "<br> \n ";
    print "Unsubscription confirmation sent to $Email_Address. Please check your inbox. <br> \n ";

    $unsub_email_subject = "$DB_ResponderName -- Your confirmation is needed.";

    # Some mail() versions have trouble handling pipe symbols. Remove them.
    $Email_Address           = stripnl(str_replace("|","",$Email_Address));
    $subscribe_email_subject = stripnl(str_replace("|","",$subscribe_email_subject));
    $subscribe_confirm_msg   = str_replace("|","",$subscribe_confirm_msg);
    $DB_OwnerName            = str_replace("|","",$DB_OwnerName);
    $DB_ReplyToEmail         = str_replace("|","",$DB_ReplyToEmail);
    $notify_email_subject    = str_replace("|","",$notify_email_subject);
    $subscribe_notify_msg    = str_replace("|","",$subscribe_notify_msg);
    $unsub_confirm_msg       = str_replace("|","",$unsub_confirm_msg);
    $unsub_email_subject     = str_replace("|","",$unsub_email_subject);
    $unsub_notify_msg        = str_replace("|","",$unsub_notify_msg);

    mail($Email_Address, $unsub_email_subject, $unsub_confirm_msg, "From: $DB_OwnerName < $DB_ReplyToEmail >");
 }
}
 else {
     print "<br> \n";
     print "Error: Missing Email address or Responder ID! <br> \n";
 }
}

elseif ($action == "confunsub") {

 if (($Responder_ID) && ($Email_Address)) {

   if (!(ResponderExists($Responder_ID)))
      { die("Responder $Responder_ID does not exist"); }

   $query = "SELECT * FROM InfResp_confirmations 
             WHERE Confirm_ResponderID = '$Responder_ID' 
               AND Confirm_EmailAddy   = '$Email_Address' 
               AND Confirm_String      = '$Confirm_String' 
               AND Confirm_Type        = 'unsub'";
   $DB_result = mysql_query($query)
        or die("Invalid query: " . mysql_error());

   if (mysql_num_rows($DB_result) > 0) {

   # Check database to make sure that they're actually subscribed.
    $ResultVar = UserIsSubscribed();
     if (!($ResultVar)) {
        GetResponderInfo();
        print "<br> \n";
        print "ERROR: $Email_Address is not subscribed to $DB_ResponderName! <br> \n";
     }
     else {

      $query = "DELETE FROM InfResp_subscribers WHERE EmailAddress = '$Email_Address' AND ResponderID = '$Responder_ID'";
      $DB_result = mysql_query($query)
           or die("Invalid query: " . mysql_error());

      $query = "DELETE FROM InfResp_customfields WHERE email_attached = '$Email_Address' AND resp_attached = '$Responder_ID'";
      $result = mysql_query($query)
                or die("Invalid query: " . mysql_error());

      $query = "DELETE FROM InfResp_confirmations 
                WHERE Confirm_ResponderID = '$Responder_ID' 
                  AND Confirm_EmailAddy   = '$Email_Address' 
                  AND Confirm_Type        = 'unsub'";
      $DB_result = mysql_query($query)
           or die("Invalid query: " . mysql_error());

      GetResponderInfo();
      print "<br> \n";
      print "Unsubscription complete - <strong> $Email_Address </strong>has been removed from $DB_ResponderName. <br> \n";

$unsub_notify_msg =
"Hello,

You are now unsubscribed from $DB_ResponderName.

Sorry to see you go. Feel free to visit us again.
Our URL: $siteURL

Take care,
$DB_OwnerName.
$DB_OwnerEmail";

     $unsub_email_subject = "$DB_ResponderName -- Bon Voyage!";

     # Some mail() versions have trouble handling pipe symbols. Remove them.
     $Email_Address           = stripnl(str_replace("|","",$Email_Address));
     $subscribe_email_subject = stripnl(str_replace("|","",$subscribe_email_subject));
     $subscribe_confirm_msg   = str_replace("|","",$subscribe_confirm_msg);
     $DB_OwnerName            = str_replace("|","",$DB_OwnerName);
     $DB_ReplyToEmail         = str_replace("|","",$DB_ReplyToEmail);
     $notify_email_subject    = str_replace("|","",$notify_email_subject);
     $subscribe_notify_msg    = str_replace("|","",$subscribe_notify_msg);
     $unsub_confirm_msg       = str_replace("|","",$unsub_confirm_msg);
     $unsub_email_subject     = str_replace("|","",$unsub_email_subject);
     $unsub_notify_msg        = str_replace("|","",$unsub_notify_msg);

     mail($Email_Address, $unsub_email_subject, $unsub_notify_msg, "From: $DB_OwnerName < $DB_ReplyToEmail >");
    }
   }
   else {
     print "<br> \n";     
     print "Your code string didn't match or has expired. Please try again. <br> \n";
   }
 } 
 else {
     if (($Responder_ID == "") OR ($Responder_ID == NULL))  {
       print "<br> \n";
       print "Error: Responder ID missing!<br>\n";
     }
     elseif (($Email_Address == "") OR ($Email_Address == NULL)) {
       print "<br> \n";
       print "Error: Email address was missing!<br>\n";
     }
     else {
       print "<br> \n";
       print "Error: There is a problem with your Email address or Responder ID! <br> \n";
     }
 }


}

# -------------------------------- Bottom --------------------------------

else {
     print "<br> \n";
     print "I'm sorry, I didn't understand your 'action' variable. Please try again. <br> \n";
}

if ($SilentMode != 1) { 
   print "<br><br><br><br><center>\n";
   print "<A HREF=\"http://www.ibasics.biz\"><img src=\"$siteURL$ResponderDirectory/images/powered-by.gif\" alt=\"Powered by Infinite Responder!\" height=\"50\" width=\"100\" border=\"0\"></A><br>\n";
   print "<br></center> \n";
}

if ($SilentMode != 1) { include('page.close.php'); }

if (($redirect_it == TRUE) AND ($redirect_afterconfirm == TRUE)) {
  $RedirLink = $AfterConfirmationLink[$Responder_ID];
  if (!(empty($AfterConfirmationLink[$Responder_ID]))) {
        header("Location: $RedirLink");
  }
}

DB_disconnect();
?>