<?php

# ------------------------------------------------
# License and copyright:
#
# This program is designed and copyrighted by
# Aaron Colman on Feb 27, 2004 under the terms 
# of the GPL provided under gpl.txt
#
# The original distribution can be found at:
# http://www.ibasics.biz
#
# I will be updating this software as time goes
# on, if you want the newest version... that's 
# where you need to go.
#
# No warranty of any kind is implied or expressed.
# You're also liable for your own actions with this
# script. If something goes wrong, it's your fault 
# and you get to deal with the consequences. I'm 
# not going to pay for it.
# ------------------------------------------------

include_once('config.php');
include('mailchecker.php');

DB_connect();

# $Auto_Subject_Prefix sets whether or not the subject line is automatically
# prefixed by the responder name in brackets.
$Auto_Subject_Prefix = 1;

# The charset being used for all messages sent out. ISO-8859-1 by default,
# but you can use anything you want (Unicode, etc).
$charset = 'ISO-8859-1';

$query = "SELECT * FROM InfResp_subscribers ORDER BY SubscriberID";
$DB_Subscriber_Result = mysql_query($query)
    or die("Invalid query: " . mysql_error());

$Send_Count = 0;

if (mysql_num_rows($DB_Subscriber_Result) > 0) {
   while ($subscriber_query_result = mysql_fetch_row($DB_Subscriber_Result)) {
     list($DB_SubscriberID, $DB_ResponderID, $DB_SentMsgs, $DB_EmailAddress,
          $DB_TimeJoined, $DB_Real_TimeJoined, $CanReceiveHTML, $DB_LastActivity, 
          $DB_FirstName, $DB_LastName, $DB_IPaddy) = $subscriber_query_result;

          $Responder_ID = $DB_ResponderID;
          GetResponderInfo();

          # I've had some bugs in MsgList where NULL, whitespace and comma are treated
          # As array elements. While I think I've fixed it, I'm not willing to risk
          # it so I'm patching it here too.

          $DB_MsgList = trim($DB_MsgList, ",");
          $DB_MsgList = trim($DB_MsgList);
          $MsgList_Array=explode(',',$DB_MsgList);
          $Max_Index = sizeof($MsgList_Array);
          if (trim($DB_MsgList) == NULL) { $Max_Index = 0; }
          if ($DB_MsgList == "") { $Max_Index = 0; }

          $Month_Joined = date("n", $DB_TimeJoined);
          $Year_Joined = date("Y", $DB_TimeJoined);
          $Day_Joined = date("j", $DB_TimeJoined);
          $Hour_Joined = date("G", $DB_TimeJoined);
          $Min_Joined = date("i", $DB_TimeJoined);
                    
          for ($i=0; $i<=$Max_Index-1; $i++) {
             $M_ID = trim($MsgList_Array[$i]);
             GetMsgInfo($M_ID);
             
             $Years_ToSend = intval($DB_MsgMonths / 12);
             $Month_ToSend = $DB_MsgMonths - ($Years_ToSend * 12);
             $Years_ToSend = $Year_Joined + $Years_ToSend;
             $Month_ToSend = $Month_Joined + $Month_ToSend;
          
             $Time_Str = $Years_ToSend. "-" .$Month_ToSend. "-" .$Day_Joined;
             $Months_Send_Timestamp = strtotime($Time_Str);
             $Time_Str = $Year_Joined. "-" .$Month_Joined. "-" .$Day_Joined;
             $Months_Join_Timestamp = strtotime($Time_Str);

             $Complete_Months_Timestamp = $Months_Send_Timestamp - $Months_Join_Timestamp;
             $Complete_ToSend_Timestamp = $Complete_Months_Timestamp + $DB_MsgSeconds + $DB_TimeJoined;

             # $Complete_Months_Timestamp is the number of months converted to seconds
             if (($Complete_ToSend_Timestamp <= time()) AND ($Send_Count <= $Max_Send_Count)) {
          
                # Check to see if the message ID is in the message list.
                if (!(IsInList($DB_SentMsgs, $DB_MsgID))) { 

                    $UnsubURL=$siteURL.$ResponderDirectory."/subhandler.php?h=$CanReceiveHTML&a=unsub&r=$Responder_ID&e=$DB_EmailAddress";

                    $NewMsgStr = $DB_SentMsgs. "," .$DB_MsgID;

                    $NewMsgStr = trim($NewMsgStr, ",");
                    $NewMsgStr = trim($NewMsgStr);

                    $DB_SentMsgs = $NewMsgStr;
                    $Message_Headers = "Return-Path: $DB_ReplyToEmail\r\n";
                    $Message_Headers = "Reply-To: $DB_ReplyToEmail\r\n";
                    $Message_Headers .= "From: $DB_OwnerName < $DB_ReplyToEmail >\r\n";

                    if ($Auto_Subject_Prefix == 1) {
                        $Send_Subject = "[$DB_ResponderName] $DB_MsgSub";
                    } else {
                        $Send_Subject = "$DB_MsgSub";
                    }
                  
                    ProcessMessageTags();

                    # Content-Type: text/plain; charset=ISO-8859-1
                    # Content-transfer-encoding: base64
                    # Content-transfer-encoding: Quoted-Printable
                    # 7bit, quoted-printable, base64
                    # 8bit, binary, x-token

                    if ($CanReceiveHTML == 1) { 
                       $Message_Headers .= "Content-type: text/html; charset=$charset\r\n\r\n";
                       $Message_Body = $DB_MsgBodyHTML;
                    }
                    else { 
                       $Message_Headers .= "Content-type: text/plain; charset=$charset\r\n\r\n";
                       $Message_Body = $DB_MsgBodyText;
                    }

                    # Some mail() versions have trouble handling pipe symbols. Remove them.
                    $DB_EmailAddress = stripnl(str_replace("|","",$DB_EmailAddress));
                    $Send_Subject    = stripnl(str_replace("|","",$Send_Subject));
                    $Message_Body    = str_replace("|","",$Message_Body);
                    $Message_Headers = str_replace("|","",$Message_Headers);
                    $DB_EmailAddress = str_replace(">","",$DB_EmailAddress);
                    $DB_EmailAddress = str_replace("<","",$DB_EmailAddress);
                    $DB_EmailAddress = str_replace('/',"",$DB_EmailAddress);
                    $DB_EmailAddress = str_replace('..',"",$DB_EmailAddress);

                    mail($DB_EmailAddress, $Send_Subject, $Message_Body, $Message_Headers);
                    $Send_Count++;

                    if ($Send_Count > $Max_Send_Count) { $i=$Max_Index; }

                    $Set_LastActivity = time();

                    $query = "UPDATE InfResp_subscribers  
                              SET SentMsgs = '$NewMsgStr',
                                  LastActivity = '$Set_LastActivity' 
                              WHERE SubscriberID = '$DB_SubscriberID'";
                    $DB_result = mysql_query($query)
                         or die("Invalid query: " . mysql_error());

                    # print "--- Subscribers ---<br>\n";
                    # print "Sub ID: $DB_SubscriberID <br>\n";
                    # print "DB_EmailAddress: $DB_EmailAddress <br>\n";
                    # print "Sent Msg list: $DB_SentMsgs <br>\n";
                    # print "NewMsgStr: $NewMsgStr <br>\n";
                    # print "HTML Y or N: $CanReceiveHTML <br> \n";
                    # print "Joined: ".date("F j, Y, g:i a", $DB_TimeJoined). " <br>\n";
                    # print "ToSend: ".date("F j, Y, g:i a", $Complete_ToSend_Timestamp). " <br>\n";
                    # print "------- DB -------<br>\n";
                    # print "Query: $query <br>\n";
                    # print "---- Messages ----<br>\n";
                    # print "Message ID: $DB_MsgID <br>\n";
                    # print "Send_Subject: $Send_Subject <br>\n";
                    # print "Message_Body: $Message_Body <br>\n";
                    # print "DB_OwnerName: $DB_OwnerName <br>\n";
                    # print "DB_ReplyToEmail: $DB_ReplyToEmail <br>\n";
                    # print "----------------- <br><br>\n";
                }
             }         
          }

     if (($Last_Activity_Trim > 0) AND ($DB_LastActivity != "") AND ($DB_LastActivity != NULL) AND ($DB_LastActivity != 0)) {
       $Day_LastActive   = date("j", $DB_LastActivity);
       $Month_LastActive = date("n", $DB_LastActivity);
       $Year_LastActive  = date("Y", $DB_LastActivity);
       $Years_ToAdd =  intval($Last_Activity_Trim / 12);
       $Months_ToAdd =  $Last_Activity_Trim - ($Years_ToAdd * 12);
       $Year_Activity_Test = $Year_LastActive + $Years_ToAdd;
       $Month_Activity_Test = $Month_LastActive + $Months_ToAdd;
       $Trim_Time_Str = $Year_Activity_Test. "-" .$Month_Activity_Test. "-" .$Day_LastActive;
       $Activity_Test_Timestamp = strtotime($Trim_Time_Str);

       # print "<strong>Time Test: </strong>".date("F j, Y, g:i a", $Activity_Test_Timestamp)."\n";
      
       if ($Activity_Test_Timestamp <= time()) {
          $query = "DELETE FROM InfResp_subscribers WHERE SubscriberID = '$DB_SubscriberID'";
          $DB_result = mysql_query($query)
               or die("Invalid query: " . mysql_error());

          $query = "DELETE FROM InfResp_customfields WHERE user_attached = '$DB_SubscriberID'";
          $result = mysql_query($query)
                    or die("Invalid query: " . mysql_error());

       }
     }
   }
 }

DB_disconnect();
?>